<?php
#############################################################
# 
# Diese Library liefert folgende Funktionen:
#
# *) Version ( $number )
# *) API ( void )
# *) OS ( void )
# *) GetDocRoot ( void )
#
# Zum Zeitpunkt der Erstellung werden folgende Umgebungen
# untersttzt: WinNT + IIS5 (ISAPI), Win98 + Apache
# (CGI u. API) AIX + Apache (Apache-API)
# Linux + Apache (CGI u. API).
#
# Im folgenden werden die Funktionen im einzelnen erklrt:
#
# Version ( $number )
# ===================
#
# Die Funktion erwartet als Argument eine Zahl. Diese Zahl
# entspricht der zurckgelieferten Stelle der PHP-Versions-
# nummer. Im Normalfall sind PHP-Versionsnummern aufgebaut 
# wie folgt: Die erste Stelle liefert die aktuelle
# Versionsnummer, gefolgt von einem Punkt gefolgt (meistens)
# von einer Null gefolgt von einem Punkt gefolgt von der
# Unterversionsnummer gefolgt von einem Zusatz.
# Beispiel: 4.0.3pl1
# In diesem Fall liefert Die Funktion mit dem Argument "1"
# den Wert "4", mit dem Argument "2" den Wert "0" mit
# dem Argument "3" den Wert "3" und mit dem Argument "4"
# den Wert "pl1". Das ist ntzlich, wenn Funktionen 
# eingesetzt werden sollen, die nur mit bestimmten
# Versionen von PHP lauffhig sind.
#
# API ( void )
# ============
# 
# Diese Funktion liefert den Wert "mod" zurck, wenn
# PHP als Server-API (Modul) luft und den Wert "cgi"
# wenn PHP als CGI-Programm ausgefhrt wird.
#
# OS ( void )
# ===========
#
# Unter dem Betriebssystem Windows, wird von dieser
# Funktion der String "win" zurckgeben. Luft auf dem
# Computer ein Unix oder Linux, gibt die Funktion 
# den String "nix" zurck.
#
# GetDocRoot ( void )
# ===================
#
# Da unter unterschiedlichen Betriebssystemen der Wert
# DOCUMENT_ROOT unterschiedlich gesetzt wird und vor 
# allem beim Einsatz von Virtuellen Hosts dieser
# Wert oft falsch belegt wird, liefert diese Funktion
# den ABSOLUTEN Pfad zum Document-Root des Webservers
# zurck.
#
# GetScriptName ( void )
# ======================
#
# Liefert den Namen des Scripts, das gerade ausgefhrt
# wird.
#
# GetScriptPath ( void )
# ======================
#
# Liefert den Pfad relativ zum Document-Root jenes Scripts, 
# das gerade ausgefhrt wird.
# 
#############################################################

if(!defined("_LIBPHPCMS_"))  
	define("_LIBPHPCMS_",TRUE);

class LibphpCMS
	{
	function LibphpCMS()
		{
		}
	
	# get the detailed version-number
	function Version($number)
		{
		$temp	= phpversion();
		$eins 	= substr( $temp, 0, strpos( $temp, '.' ) );
		$temp	= substr( $temp, strpos( $temp, '.' ) + 1 );
		$zwei	= substr( $temp, 0, strpos( $temp, '.' ) );
		$temp	= substr( $temp, strpos( $temp, '.' ) + 1 );
		$drei	= substr( $temp, 0, 1 );
		$vier	= substr( $temp, 1 );
		
		switch ($number)
			{
			case 1:
				return $eins;
			case 2:
				return $zwei;
			case 3:
				return $drei;
			case 4:
				return $vier;
			}			
		}
	
	# get module or cgi
	function API()
		{
		global $SERVER_SOFTWARE;
		if ( $this->Version(1) > 4 OR ($this->Version(1) == 4 AND $this->Version(2) == 0 AND $this->Version(3) >= 1 ) )
			{
			$sapi_type = php_sapi_name();
			if (stristr($sapi_type,"apache"))
				return 'mod';
			if (stristr($sapi_type , "isapi"))
				return 'mod';
			if (stristr($sapi_type , "cgi"))
				return 'cgi';				
			}
			
		if ( stristr( $SERVER_SOFTWARE, 'PHP' ) AND !stristr( $SERVER_SOFTWARE, 'SCRIPT' )) 
			return 'mod';
			
		return 'cgi';
		}
		
	# get OS
	function OS()
		{
		global $SERVER_SOFTWARE, $PATH;

		if ( stristr ( $SERVER_SOFTWARE, 'Win' ) )
			return 'win';
		if ( stristr ( $SERVER_SOFTWARE, 'Microsoft' ) )
			return 'win';
		if ( stristr ( $SERVER_SOFTWARE, 'Unix' ) )	
			return 'nix';
		
		if ( stristr ( $PATH, 'C:' ) )
			return 'win';
		if ( stristr ( $PATH, 'D:' ) )
			return 'win';
		if ( stristr ( $PATH, 'E:' ) )
			return 'win';
		if ( stristr ( $PATH, '/X11' ) )
			return 'nix';			
		}
		
	function GetScriptName()
	{
		global $SCRIPT_NAME, $PATH_INFO;
		
		if ( $this->OS() == 'win' AND $this->API() == 'cgi' )
		{
				if ( strlen($PATH_INFO) == 0 ) 
					return basename($SCRIPT_NAME);
				else
					return basename ($PATH_INFO);
		}	        
		else
		{
			if ( $this->OS() == 'nix' AND $this->API() == 'cgi' AND isset ($PATH_INFO ))
				return basename ( $PATH_INFO );
			return basename ( $SCRIPT_NAME );
		}
	}
		
	function GetScriptPath()
		{
		global $SCRIPT_NAME, $PATH_INFO;

		if ( $this->OS() == 'win' AND $this->API() == 'cgi' ) 
			{
			if ( strlen($PATH_INFO) == 0 ) 
				{
				$tmppfad = str_replace(basename($SCRIPT_NAME)," ",$SCRIPT_NAME);
				$pos = strpos($SCRIPT_NAME,basename($SCRIPT_NAME));
				$slo22 = substr ( $tmppfad, 0, $pos-1 );
				return $slo22;
				}
			else
				return dirname( $PATH_INFO );
			}
		else
			if ( $this->OS() == 'nix' AND $this->API() == 'cgi' AND isset ($PATH_INFO ))
				return dirname ( $PATH_INFO );
		return dirname ( $SCRIPT_NAME );
		}
		
	function GetDocRoot()
		{
		global $PATH_TRANSLATED, $SCRIPT_FILENAME;
		
		$SelfDir = $this->GetScriptPath();

		if ( $this->OS() == 'win' )
			{
			$Directory = $PATH_TRANSLATED;
			$Directory = str_replace ('\\\\', '\\', $Directory );
			}
		else
			{
			if ($this->API() == 'cgi' AND isset ($PATH_TRANSLATED))
				$Directory = $PATH_TRANSLATED;
			else
				$Directory = $SCRIPT_FILENAME;
			}
			
		if ( $this->OS() == 'win' )
			{
			$temp = str_replace ('\\', '/', $Directory );
			$SelfPos = strpos ( $temp, $SelfDir );
			}
		else
			$SelfPos = strpos ( $Directory, $SelfDir );
		
		
		return str_replace ('\\', '/', substr ( $Directory, 0, $SelfPos ) );
		}
		
	function LockFile($datei, $status)
		{
				
		if ($status == 'set')
			{
			if (file_exists($datei.'.lck'))
				return false;
			$fp = fopen ( $datei.'.lck', 'a+' );
			fwrite( $fp, ' ', 1);
			fclose ( $fp );
			return true;
			}
			
		if ( $status == 'release' )
			{
			unlink ( $datei.'.lck' );
			}
		
		}
		
	function NoCache()
		{
		global $SERVER_SOFTWARE;
		Header ('Server: '.$SERVER_SOFTWARE.' phpCMS/1.1.6'."\n");
		Header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT\n"); 			// Date in the past
		Header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT\n"); 	// always modified
		Header ("Cache-Control: no-cache, must-revalidate\n"); 		// HTTP/1.1
		Header ("Pragma: no-cache\n"); 					// HTTP/1.0
		}

	function ExtractValue($FIELD, $ValueName)
		{
		$ValueName = $ValueName.'="';
		$ValueLength = strlen ( $ValueName );
		$Temp = trim ( substr ( $FIELD, strpos ( $FIELD, $ValueName ) + $ValueLength ) );
		$Temp = trim ( substr ($Temp, 0, strpos ( $Temp, '"' ) ) );
		return $Temp;
		}

	function MakePlugin(	$PluginPath, 
				$PluginType, 
				&$PageContent, 
				&$CacheState,
				&$ClientCache,
				&$ProxyCacheTime,
				&$Tags,
				&$Menu,
				&$plugindir)
		{
		# later: check, if the plugin is active on this page
		
		# check if the plugin is dynamic. If so set the page to non-cache
		if ( strtoupper($PluginType) != 'STATIC' )
			{
			$CacheState = 'off';
			$ClientCache = 'off';
			$ProxyCacheTime = -4;
			}
			
		# making arguments global to plugin
		reset ($GLOBALS);
        $phpCMS = 0;
        $toeval ='global $phpCMS';
		while (list($k, $value) = each ($GLOBALS)) 
		{ 
			//${$key} = $value;
			if (strlen($k) > 0 and !strstr($k, '-') and $k!='$' and $k!='/' and !strstr($k,',') and !strstr($k,';'))
			{
				$toeval .= ', $'.$k;		
			}
		}
        $toeval.=';';
		eval ($toeval);
		
		reset ($GLOBALS);
		chdir ($DEFAULTS->DOCUMENT_ROOT.$CHECK_PAGE->path);
		# running the plugin
		if ($PHP->Version(1) >= 4)
			ob_start(); 

		include ($PluginPath);
		
		if ($PHP->Version(1) >= 4)
			{
			$TempBuffer = ob_get_contents(); 
			ob_end_clean(); 
			}
		
		if ( isset ( $PluginBuffer ) )
			{
			if ( !isset ($TempBuffer) )
				{
				return $PluginBuffer;
				}
			else
				{
				$PluginBuffer[count($PluginBuffer)] = $TempBuffer;
				return $PluginBuffer;
				}
			}
		else
			{
			if ( !isset ($TempBuffer) )
				return;
			else
				{
				$PluginBuffer[0] = $TempBuffer;
				return $PluginBuffer;
				}
			}
				
		}
	}
?>
