<?php
########################################################################	
#
# set some basic vars
#
########################################################################

$PHPCMS_DOC_ROOT	= $DEFAULTS->DOCUMENT_ROOT;
$SEARCHDATADIR 	= $PHPCMS_DOC_ROOT.$session->vars['datadir'];
$MAX_BYTE_SIZE		= $session->vars['maxbytesize'];
$MIN_WORD_SIZE		= $session->vars['minwordsize'];

$e = 0;
if ( isset ($session->vars['excludepath1']) )
	$EXDIR[$e++] = $session->vars['excludepath1'];
if ( isset ($session->vars['excludepath2']) )
	$EXDIR[$e++] = $session->vars['excludepath2'];
if ( isset ($session->vars['excludepath3']) )
	$EXDIR[$e++] = $session->vars['excludepath3'];	
unset ($e);

########################################################################
#
# patterns for documents
# ======================
#
# to get the content from HTML-title and HTML-body change the regex
# for each extension. you can easily add new extensions in the
# same way as for phpCMS here. these values work for me.
#
########################################################################

$EXTENSION[0]['type']		= 'htm';
$EXTENSION[0]['doc_start']	= '<';
$EXTENSION[0]['name']		= '.htm';
$EXTENSION[0]['title_start']	= "<[:space:]*title[^>]*>";
$EXTENSION[0]['title_stop']	= "<[:space:]*/title[^>]*>";
$EXTENSION[0]['body_start']	= "<body[^>]*>";
$EXTENSION[0]['body_stop']	= "</body[^>]*>";

$EXTENSION[1]['type']		= 'html';
$EXTENSION[1]['doc_start']	= '<';
$EXTENSION[1]['name']		= '.html';
$EXTENSION[1]['title_start']	= "<[:space:]*title[^>]*>";
$EXTENSION[1]['title_stop']	= "<[:space:]*/title[^>]*>";
$EXTENSION[1]['body_start']	= "<body[^>]*>";
$EXTENSION[1]['body_stop']	= "</body[^>]*>";

$PEXTENSION['doc_start']	= '{';
$PEXTENSION['name']		= '.htm';
$PEXTENSION['title_start']	= "\{TITEL\}";
$PEXTENSION['title_stop']	= "\{";
$PEXTENSION['body_start']	= "\{CONTENT\}";
$PEXTENSION['body_stop']	= '\{';

########################################################################
#
# now we are going to make the stop-words
#
# the stop-word-file should contain a list of words
# sepperated with a linebreak for each word.
#
########################################################################
$temp = $PHPCMS_DOC_ROOT;
$temp = $temp.$session->vars['stopwords'];
$STOP = file ($temp);
$STOP_MAX = 0;
$STOP_COUNT = count($STOP);
for ($i=0; $i<$STOP_COUNT; $i++)
	{
	if (strlen($STOP[$i]) > $STOP_MAX)
		$STOP_MAX = strlen($STOP[$i]);
	}
unset ($STOP_COUNT);

########################################################################
#
# this is the main-function of the indexer
#
########################################################################

function index_entry($title, &$body, $page)
	{
	global $SEARCHDATADIR, $STOP, $STOP_MAX, $MIN_WORD_SIZE;

	# remove some unwanted chars
	
	$body = $title.' '.$body;
	$body = str_replace ('!',' ',$body);
	$body = str_replace (':',' ',$body);
	$body = str_replace (',',' ',$body);
	$body = str_replace (';',' ',$body);
	$body = str_replace ('&#',' ',$body);
	$body = str_replace ('"',' ',$body);
	$body = str_replace ('\'',' ',$body);
	$body = str_replace ('&lt',' ',$body);
	$body = str_replace ('&gt',' ',$body);
	$body = str_replace ('$',' ',$body);
	$body = str_replace ('%',' ',$body);
	$body = str_replace ('&',' ',$body);
	$body = str_replace ('(',' ',$body);
	$body = str_replace (')',' ',$body);
	$body = str_replace ('[',' ',$body);
	$body = str_replace (']',' ',$body);
	$body = str_replace ('{',' ',$body);
	$body = str_replace ('}',' ',$body);
	$body = str_replace ('?',' ',$body);
	$body = str_replace ('*',' ',$body);
	$body = str_replace ('#',' ',$body);
	$body = str_replace ('+',' ',$body);
	$body = str_replace ('|',' ',$body);
	$body = str_replace ('^',' ',$body);
	$body = str_replace ("'",' ',$body);
	$body = str_replace ('',' ',$body);
	$body = str_replace ('`',' ',$body);
	$body = str_replace ('~',' ',$body);
	$body = str_replace ('@',' ',$body);
	$body = str_replace ('\\',' ',$body);
	$body = str_replace ('',' ',$body);
	$body = str_replace ('',' ',$body);
	$body = str_replace ('=',' ',$body);
	$body = str_replace ('.',' ',$body);
	$body = str_replace ("\n",' ',$body);
	$body = str_replace ('/',' ',$body);
	$body = str_replace ('1',' ',$body);
	$body = str_replace ('2',' ',$body);
	$body = str_replace ('3',' ',$body);
	$body = str_replace ('4',' ',$body);
	$body = str_replace ('5',' ',$body);
	$body = str_replace ('6',' ',$body);
	$body = str_replace ('7',' ',$body);
	$body = str_replace ('8',' ',$body);
	$body = str_replace ('9',' ',$body);
	$body = str_replace ('0',' ',$body);
	$body = str_replace ('	',' ',$body);
	
	# make all words uppercase. search is no casesensitive
	# at this time. this increase performance very much.
	
	$body = strtoupper($body);
	$body = trim($body);
	
	# jump back, if the content of the
	# body-field is shorter as the 
	# minimum-word-size.
	
	if (strlen($body) < $MIN_WORD_SIZE) return;
	$wordAr = explode (' ', $body);
	$old_val = '';
	$doit = true;
	$indexer = 0;
	
	sort($wordAr);
	while (list ($key, $val) = each ($wordAr)) 
		{
		$val = trim($val);
		
		if (strlen($val) == 0 ) continue;
		
		# workaround for some trouble
		# with strtoupper() on unix-hosts
		
		$val = str_replace ('','',$val);
		$val = str_replace ('','',$val);
		$val = str_replace ('','',$val);
		
		if($val == $old_val)
			{
			if ($doit == false) continue;
			
			# same as bevore so only increment
			# the word-counter for this page.
			
			$ResultArray[$indexer-1]['c']++;
			}
		else
			{
			# we dont need to make all checks on every word.
			# if there are two same words, we could also
			# memory the checks.
			
			$old_val = $val;
			$doit = true;
			
			# removing some unwanted chars at
			# beginning and end of a word.
			
			while ( substr($val,0,1) == '-' OR substr($val,0,1) == '_')
				$val = substr($val,1);
			while (substr($val,-1) == '-' OR substr($val,-1) == '_')
				$val = substr($val,0,-1);
			
			# checking minimum word-size
			
			if(strlen( $val) < $MIN_WORD_SIZE )
				{
				$doit = false;
				continue;
				}
			
			# only check stop-words, if
			# the length of the word to index
			# is shorter then the longest stop-word.
			# checking the stop-word-array is
			# very time-consuming so check only
			# if really nessesary.
			
			if ( strlen( $val ) < $STOP_MAX )
				{
				if ( CheckArray ( $STOP, $val ) )
					{
					$doit = false;
					continue;
					}
				}
				
			if ($doit)
				{
				
				# all checks passed => add 
				# this word to the index.
				
				$doit = true;
				$ResultArray[$indexer]['n']=$val;
				$ResultArray[$indexer]['u']=$page;
				$ResultArray[$indexer]['c']=1;
				$indexer++;
				}
			
			}
		}
		
	# return the result-array, wich looks like this:
	# $indexer = Array-Index 0-x
	# $ResultArray[$indexer]['n'] = the word to index
	# $ResultArray[$indexer]['u'] = the index of the page in wich the word was found
	# $ResultArray[$indexer]['c'] = the occurences of the word in the page
	
	if (isset($ResultArray))
		return $ResultArray;
	else
		return;
	}
	
########################################################################
#
# checks, if an entry is in a array.
# needed for checking the stop-word-array
#
########################################################################

function CheckArray($sarray,$entry)
	{
	global $PHP;
	
	$ac = count($sarray);
	for ($i=0; $i<$ac; $i++)
		{
		if (trim($sarray[$i]) == trim($entry)) 
			return true;
		}
	return false;		
	}	

########################################################################
#
# reduce the length of the body-field for displaying
# in the search-result. you can change the length
# with the variable $MaxChar.
#
########################################################################

function MakeShortWords($words)
	{
	global $session;
	
	$MaxChar = $session->vars['textsize'];;
	
	$words = substr ( $words, 0, $MaxChar*2 );
	$words = str_replace ( '  ',' ',$words );
	$words = substr ( trim ( strip_tags ( $words ) ) , 0 , $MaxChar );
	$lpos  = strrpos ( $words, ' ' );
	$words = substr ( $words, 0, $lpos );
	$words = str_replace ( ';' , '##' , $words );
	return $words;
	}
	
########################################################################
#
# trimming the title-string and
# replace alle occurences of ";",
# because we use this for splitting
# the entry later.
#
########################################################################

function TrimTitle($words)
	{
	$words = trim ( $words );
	$words = str_replace ( ';' , '##' , $words );
	return $words;
	}

########################################################################
#
# i know. :-)
#
########################################################################

function make_german(&$body)
	{
	$body = str_replace('>','> ',$body);
	$body = str_replace ('&Auml;','',$body);
	$body = str_replace ('&auml;','',$body);
	$body = str_replace ('&ouml;','',$body);
	$body = str_replace ('&Ouml;','',$body);
	$body = str_replace ('&uuml;','',$body);
	$body = str_replace ('&Uuml;','',$body);
	$body = str_replace ('&szlig;','',$body);
	$body = strip_tags($body);
	}	

########################################################################
#
# this function do the "hard" work. writing the
# file-index, writing the word-index and so on.
#
########################################################################

function write_file_entry($FileIndex, $actual_entry, $titel, &$body, &$written)
	{
	global $SEARCHDATADIR, $PHPCMS_DOC_ROOT, $MIN_WORD_SIZE;
	
	# beautify the content.
	make_german($body);
	make_german($titel);
	
	# we need this later for the status-display
	$written.= substr(trim($actual_entry),strlen($PHPCMS_DOC_ROOT)).'<br>';
	
	$fp = fopen($SEARCHDATADIR.'/files.db','ab+');
	
	# the entry in the file.db looks like this:
	# index_of_the_page;title-text_of_the_page;body-text_of_the_page
	# eg: 33;the title;the body
	$entry = substr(trim($actual_entry),strlen($PHPCMS_DOC_ROOT));
	$entry .=';'.TrimTitle($titel).';'.MakeShortWords($body)."\n";
	fputs ($fp, $entry, strlen($entry));
	fclose ($fp);
	
	$ResultArray = index_entry($titel,$body,$FileIndex);
	$indexer = count($ResultArray);
	
	# for write-performance, we write all
	# index-entrys in one string and append
	# this string to the index.
	
	$words_to_write = '';	
	for ($i = 0; $i < $indexer; $i++)
		{
		unset ( $entry );
		$entry = $ResultArray[$i]['n'].'#'.$ResultArray[$i]['u'].'#'.$ResultArray[$i]['c'];
		$words_to_write = $words_to_write."\n".$entry;
		}
		
	if (strlen($words_to_write) > $MIN_WORD_SIZE)
		{
		$fp = fopen($SEARCHDATADIR.'/words.tmp','ab+');
		fwrite ($fp, $words_to_write, strlen($words_to_write));
		fclose ( $fp );
		
		}	
	}
	
########################################################################
#
# now looping thru the files wichare to index
#
########################################################################
	
function doindex()
	{
	global $DEFAULTS, $SEARCHDATADIR,$EXTENSION,$PEXTENSION, $MESSAGES, $MAX_BYTE_SIZE, $session;
	
	# because we make more reloades, this check if we are ready.	
	if (!file_exists($SEARCHDATADIR.'/files_to_index.txt') OR filesize($SEARCHDATADIR.'/files_to_index.txt') < 3)
		{
		unlink($SEARCHDATADIR.'/files_indexed.txt');
		unlink($SEARCHDATADIR.'/files_to_index.txt');
		$session->set_var('start', '0');
		$session->set_var('task', 'MERGER1');
		merger1();
		soft_exit();
		}
	# reading the files we have to process	
	$dirarray = file($SEARCHDATADIR.'/files_to_index.txt');
	
	# getting the actual fileindex
	if (file_exists ($SEARCHDATADIR.'/files_indexed.txt'))
		{
		$redyarray = file ($SEARCHDATADIR.'/files_indexed.txt');
		$filecounter = count($redyarray);
		unset ( $redyarray );
		}
	else
		$filecounter = 0;
	
	# init some counters
	$entry_counter = 0;
	$continue_index = 1;
	$actual_filesize = 0;
	$written = '';
	
	while ($continue_index == 1)
		{
		unset ($body);
		unset ($titel);
		
		$actual_entry = trim($dirarray[$entry_counter]);

		$raw_value = file($actual_entry);
		$value = join('',$raw_value);
		$value = str_replace ( "\n",' ',$value);
		$value = str_replace ( "\r",' ',$value);
		$value = str_replace ( "\t",' ',$value);
		$epos = strrpos($actual_entry,'.');
		$extension = substr($actual_entry,$epos);
		
		# if it is an phpCMS-file, use this
		if ($extension == $DEFAULTS->PAGE_EXTENSION AND substr($value,0,1) == $PEXTENSION['doc_start'])
			{
			eregi($PEXTENSION['title_start']."([^".$PEXTENSION['title_stop']."]*)", $value, $titel);
			eregi($PEXTENSION['body_start']."([^".$PEXTENSION['body_stop']."]*)", $value, $body);
			write_file_entry($filecounter, $actual_entry, $titel[1], $body[1], $written);
			}
		else
			{
			# walk thru all other extensions, wich ar defined
			for ($i=0; $i < count ($EXTENSION); $i++)
				{
				if ($extension != $EXTENSION[$i]['name']) continue;
				eregi($EXTENSION[$i]['title_start']."(.*)".$EXTENSION[$i]['title_stop'], $value, $titel);
				eregi($EXTENSION[$i]['body_start']."(.*)".$EXTENSION[$i]['body_stop'], $value, $body);
				write_file_entry($filecounter, $actual_entry, $titel[1], $body[1], $written);
				}
			}

		$entry_counter++;
		$filecounter++;
		# stop if no more entrys ar aviable
		if ($entry_counter == count($dirarray))
			$continue_index = -1;
		else
			{
			# calculate the size of the next file,
			# because we have a tim-limit on the server.
			# if size is bigger as the limit,
			# force an reload of the page.
			
			$actual_filesize = $actual_filesize+filesize($actual_entry);
			$next_entry = trim($dirarray[$entry_counter]);
			$next_filesize = filesize($next_entry);
			if (($actual_filesize+$next_filesize) > $MAX_BYTE_SIZE)
				$continue_index = -1;
			}
		}	
	# writing the process for the files
	
	if (file_exists ($SEARCHDATADIR.'/files_indexed.txt'))
		{
		$redyarray = file ($SEARCHDATADIR.'/files_indexed.txt');
		$fc = count($redyarray);
		for ($i = 0; $i < $entry_counter; $i++)
			{
			$redyarray[$fc+$i] = $dirarray[$i];
			}
		}
	else
		{
		for ($i = 0; $i < $entry_counter; $i++)
			{
			$redyarray[$i] = $dirarray[$i];
			}
		}
		
	$fp = fopen ($SEARCHDATADIR.'/files_indexed.txt', 'w');
	$files_indexed = count ($redyarray);
	for ($i=0; $i< $files_indexed; $i++)
		{
		fputs ($fp,trim($redyarray[$i])."\n");
		}
	fclose ($fp);
	
	$fp = fopen ($SEARCHDATADIR.'/files_to_index.txt', 'w');
	$files_to_index = count ($dirarray);
	for ($i=$entry_counter; $i< $files_to_index; $i++)
		{
		fputs ($fp, trim($dirarray[$i])."\n");
		}
	fclose ($fp);
	
	# force thr reload of this page
	b_write('<html>');
	b_write('<head>');
	b_write('<META http-equiv="refresh" content="0; URL='.make_link('&select=INDEXER').'">');
	b_write('</head>');
	b_write('<body>');
	# writing som status infos, collected in write_file_entry()
	b_write( '<br><font face="Arial, Helvetica, Verdana" size=3><b>' );
	b_write( $MESSAGES[200].'</b></font><br>' );
	b_write( '<font face="Arial, Helvetica, Verdana" size=2>' );
	b_write( $MESSAGES[201].$files_indexed.$MESSAGES[202].'<br>' );
	b_write( $MESSAGES[203].$files_to_index.$MESSAGES[204].'<br>' );
	b_write( $MESSAGES[205].'<hr>' );
	b_write( $written );
	b_write('</font></body>');
	b_write('</html>');
	
	soft_exit();
	}
	
function get_dir_list($dire)
	{
	global $DEFAULTS,$EXTENSION,$PEXTENSION,$EXDIR,$PHPCMS_DOC_ROOT;

	$d = dir ( $dire );
	while ( $entry = $d->read() ) 
		{
		$test = substr($dire.'/'.$entry,strlen($PHPCMS_DOC_ROOT));
		if ( $entry == '.' OR $entry == '..' ) continue;
		if ( CheckArray($EXDIR,$test)) continue;
		if ( is_dir ($dire.'/'.$entry) )
			{
			$add_array = get_dir_list($dire.'/'.$entry);
			if (!isset($add_array)) continue;
			for ($i=0; $i < count($add_array); $i++)
				{
				if (!isset($ReturnArray))
					$ReturnArray[0] = $add_array[$i];
				else
					$ReturnArray[count($ReturnArray)] = $add_array[$i];
				}
			continue;
			}
		$extension = substr($entry,strrpos($entry,'.'));
		$doit = false;
		if ($extension == $DEFAULTS->PAGE_EXTENSION)
			$doit = true;
		for ($i=0; $i < count ($EXTENSION); $i++)
			{
			if ($extension != $EXTENSION[$i]['name']) 
				continue;
			else
				{
				$doit = true;
				break;
				}
			}
		if (!$doit) continue;
		if (!isset($ReturnArray))
			$ReturnArray[0] = $dire.'/'.$entry;
		else
			$ReturnArray[count($ReturnArray)] = $dire.'/'.$entry;
		}
	if (isset($ReturnArray))
		return $ReturnArray;
	else 
		return;
	}

function index()
	{
	global $DEFAULTS, $session, $PHP, $SEARCHDATADIR;
	
	# kill old index-files
	$dire = $SEARCHDATADIR;
	$d = dir ( $dire );
	while ( $entry = $d->read() ) 
		{
		if ( trim($entry) == '.' ) continue;
		if ( trim($entry) == '..' ) continue;
		if ( is_dir ($SEARCHDATADIR.'/'.$entry) ) continue;
		unlink ($SEARCHDATADIR.'/'.$entry);
		}
	
	$session->set_var('globaltime', time());
	
	if ( trim ( $session->vars['startpath'] ) == '/' )
		$indexdir = $PHP->GetDocRoot();
	else
		$indexdir = $PHP->GetDocRoot().$session->vars['startpath'];

	$dirarray = get_dir_list($indexdir);
	chdir ($SEARCHDATADIR);
	$fp = fopen('files_to_index.txt','w');
	for ($i=0; $i < count ($dirarray); $i++)
		{
		fputs ($fp, $dirarray[$i]."\n");
		}
	fclose ($fp);
	$session->set_var('task', 'INDEX');
	doindex();
	}

########################################################################
#
# merger-functions
#
########################################################################

function merger1()
	{
	global $SEARCHDATADIR, $MAX_BYTE_SIZE, $session, $MESSAGES;
	
	$starttime=time();
	$TempWordsCount = 0;
	$index = 0;
	$start = $session->vars['start'];
	
	$fp = fopen($SEARCHDATADIR.'/words.tmp', 'rb');
	fseek ($fp, $start);

	while ((($TempWordsCount+100) < $MAX_BYTE_SIZE) AND !feof($fp))
		{
		$TempWords[$index] = trim(fgets($fp,4096));
		if ( strlen($TempWords[$index]) == 0 ) continue;
		$TempWordsCount = $TempWordsCount+ strlen($TempWords[$index])+1;
		$index++;
		}
	if (feof($fp))
		$session->set_var('task', 'MERGER2');
	fclose ($fp);
	
	$next_start = $start+$TempWordsCount;
	$session->set_var('start', $next_start);
	
	
	for ($i=0; $i<$index; $i++)
		{
		list($word, $file) = explode('#',$TempWords[$i]);
		$word_len = strlen($word);
		
		$fp = fopen ( $SEARCHDATADIR.'/t'.$word_len.'.db', 'ab+' );
		$entry = $TempWords[$i]."\n";
		fputs ($fp, $entry, strlen($entry));
		fclose ($fp);
				
		}

		b_write('<html>');
		b_write('<head>');
		b_write('<META http-equiv="refresh" content="0; URL='.make_link('&select=INDEXER').'">');
		b_write('</head>');
		b_write('<body>');
		# writing som status infos, collected in write_file_entry()
		b_write( '<br><font face="Arial, Helvetica, Verdana" size=3><b>' );
		b_write( $MESSAGES[206].'</b></font><br>' );
		b_write( '<font face="Arial, Helvetica, Verdana" size=2>' );
		b_write( $MESSAGES[207].$next_start.$MESSAGES[208].filesize($SEARCHDATADIR.'/words.tmp').$MESSAGES[209].'<hr>' );
		b_write( $MESSAGES[210].date("H:i:s", $starttime).'<br>');
		b_write( $MESSAGES[211].date("H:i:s", time()).'<br>');
		b_write( $MESSAGES[212].date("i:s", (time()-$starttime)).'<br>');		
		b_write('</font></body>');
		b_write('</html>');
	}
	
function merger2()
	{
	global $SEARCHDATADIR, $session, $MESSAGES;
	
	$starttime=time();
	
	# ffne directory,
	$dire = $SEARCHDATADIR;
	$d = dir ( $dire );
	while ( $entry = $d->read() ) 
		{
		if ( substr ( $entry, 0, 1 ) == 't' )
			{
			$current_file = $SEARCHDATADIR.'/'.$entry;
			break;
			}
		}
	
	# hole erstes temp-file
	if (isset($current_file))
		{
		$TempArray = file ( $current_file );
		$index = 0;
		for ($i=0; $i<count($TempArray); $i++)
			{
			$TempArray[$i] = trim($TempArray[$i]);
			if (strlen($TempArray[$i]) < 1) continue;
			
			list ( $word, $seite, $anzahl ) = explode ( '#', $TempArray[$i] );
			
			if (isset($WordArray[$word]))
				{
				$DataArray[$WordArray[$word]] = $DataArray[$WordArray[$word]].'+'.$seite.'*'.$anzahl;
				}
			else
				{
				$WordArray[$word] = $index;
				$IndexArray[$index] = $word;
				$DataArray[$index] = $seite.'*'.$anzahl;
				$index ++;
				}			
			}
			
		$output_file = $SEARCHDATADIR.'/words.db';

		$fp = fopen ($output_file, 'ab+');
		while ( list($k, $v) = each ($IndexArray) )
			{
			$v = $v."\n";
			$size = strlen( $v );
			fputs ($fp, $v, $size);
			}
		fclose ($fp);

		$output_file = $SEARCHDATADIR.'/data.db';

		$fp = fopen ($output_file, 'ab+');
		while (list($k, $v) = each ($DataArray) )
			{
			$v = $v."\n";
			$size = strlen( $v );
			fputs ($fp, $v, $size);
			}
		fclose ($fp);
		
		unlink ($current_file);
		
		# write timing
		$log_entry = 'current wordlength:'.substr ($entry, 1, strrpos ( $entry, '.' )-1);
		$log_entry .= ' time: '.date("H:i:s", (time()-$starttime))."\n";
		$fp = fopen ($SEARCHDATADIR.'/log.txt', 'a+');
		$size = strlen($log_entry);
		fputs ($fp, $log_entry, $size);
		fclose ($fp);

		b_write('<html>');
		b_write('<head>');
		b_write('<META http-equiv="refresh" content="0; URL='.make_link('&select=INDEXER').'">');
		b_write('</head>');
		b_write('<body>');
		# writing som status infos, collected in write_file_entry()
		b_write( '<br><font face="Arial, Helvetica, Verdana" size=3><b>' );
		b_write( $MESSAGES[213].'</b></font><br>' );
		b_write( '<font face="Arial, Helvetica, Verdana" size=2>' );
		b_write( $MESSAGES[214].substr ($entry, 1, strrpos ( $entry, '.' )-1).'<hr>' );
		b_write( $MESSAGES[210].date("H:i:s", $starttime).'<br>');
		b_write( $MESSAGES[211].date("H:i:s", time()).'<br>');
		b_write( $MESSAGES[212].date("i:s", (time()-$starttime)).'<br>');
		b_write('</font></body>');
		b_write('</html>');
		}
	else
		{
		
		if (trim($session->vars['gzipcompr']) == 'on' AND extension_loaded ('zlib'))
			{
			
			$WordIndex = file($SEARCHDATADIR.'/words.db');
			$WordToWrite = implode("",$WordIndex);
			$gp1 = gzopen($SEARCHDATADIR.'/words.gz', 'wb');
			gzwrite ($gp1,$WordToWrite);
			gzclose ($gp1);
			unlink ($SEARCHDATADIR.'/words.db');
			
			$FileDB = file ($SEARCHDATADIR.'/files.db');	
			$FileToWrite = implode("",$FileDB);
			$gp2 = gzopen($SEARCHDATADIR.'/files.gz', 'wb');
			gzwrite ($gp2,$FileToWrite);
			gzclose ($gp2);
			unlink ($SEARCHDATADIR.'/files.db');
			
			$DataArray = file ($SEARCHDATADIR.'/data.db');
			$DataToWrite = implode("",$DataArray);
			$gp3 = gzopen($SEARCHDATADIR.'/data.gz', 'wb');
			gzwrite ($gp3,$DataToWrite);
			gzclose ($gp3);
			unlink ($SEARCHDATADIR.'/data.db');

			unlink ($SEARCHDATADIR.'/words.tmp');
			$globaltime = date("i:s", (time() - $session->vars['globaltime']));
			$session->destroy();
			
			b_write( '<html>');
			b_write( '<br><font face="Arial, Helvetica, Verdana" size=3><b>' );
			b_write( $MESSAGES[215].'</b></font><br>' );
			b_write( '<font face="Arial, Helvetica, Verdana" size=2>' );
			b_write( $MESSAGES[216].$globaltime );
			b_write('</font></body>');
			b_write( '</html>');
			exit;
			
			}
		else
			{
			unlink ($SEARCHDATADIR.'/words.tmp');
			$globaltime = date("i:s", (time() - $session->vars['globaltime']));
			$session->destroy();
						
			b_write( '<html>');
			b_write( '<br><font face="Arial, Helvetica, Verdana" size=3><b>' );
			b_write( $MESSAGES[217].'</b></font><br>' );
			b_write( '<font face="Arial, Helvetica, Verdana" size=2>' );
			b_write( $MESSAGES[216].$globaltime );
			b_write('</font></body>');
			b_write( '</html>');
			exit;
			}
		}	
	}

if ( isset( $session->vars['task'] ) )
	$task = $session->vars['task'];
else
	$task = '';

switch ($task)
	{
	case 'MERGER1':
		merger1();
		soft_exit();
	case 'MERGER2':
		merger2();
		soft_exit();		
	case 'INDEX':
		doindex();
		soft_exit();
	case 'STARTINDEX':
		index();
		soft_exit();
	default:
		index();
		soft_exit();
	}
	

?>