<?php
########################################################################
#
# class search
#
########################################################################
#
# author	Michael Brauchl
# date		02.06.2001
# version	0.0.1
# licenze	GPL
#
########################################################################
#
# this class is part of the phpCMS-project and you are not allowed to 
# use it out of this project.
# suggestions to bugfixes are welcome under mcyra@chello.at
#
########################################################################

########################################################################
#
# include some nessesary librarys
#
########################################################################

if(!defined("_SESSION_"))
	include ($PHPCMS_INCLUDEPATH.'/class.session_phpcms.php');
if(!defined("_ERROR_"))
	include ($PHPCMS_INCLUDEPATH.'/class.lib_error_phpcms.php');
if(!defined("_DATACONTAINER_"))		
	include ($PHPCMS_INCLUDEPATH.'/class.lib_data_file_phpcms.php');
if(!defined("_FORM_"))		
	include ($PHPCMS_INCLUDEPATH.'/class.form_phpcms.php');
include ($PHPCMS_INCLUDEPATH.'/language.'.$DEFAULTS->LANGUAGE );

########################################################################
#
# some helpful global functions
#
########################################################################

function soft_exit()
	{
	global $session;
	$session->close();
	exit;
	}
	
function make_link($option)
	{
	global $session, $DEFAULTS;
	$url = $DEFAULTS->SCRIPT_PATH.'/'.$DEFAULTS->SCRIPT_NAME.'?phpcmsaction=search&action='.$option;
	return $session->write_link($url);
	}
	
# writes text out to the browser. if the indexer later is used
# as plugin or as part of phpCMS, we can easily omit header-errors,
# because we could write to a buffer instead to the browser.

function b_write($text)
	{
	echo $text."\n";
	}	

########################################################################	
# authenticate user
########################################################################

$session = new session;

if ( isset ( $HTTP_POST_VARS['seceret'] ) )
	{
	if ( $HTTP_POST_VARS['seceret'] == $DEFAULTS->PASS )
		$session->set_var('login', 'OK');
	else
		soft_exit();
	}

if ( $session->vars['login'] != 'OK' )
	soft_exit();
	
########################################################################	
# menu
########################################################################

function draw_search_menu( $message = '' )
	{
	global $formdata, $DEFAULTS, $PHPCMS_INCLUDEPATH, $MESSAGES;
	
	$DATADB_PATH = substr($PHPCMS_INCLUDEPATH, strlen($DEFAULTS->DOCUMENT_ROOT));
	if ( !isset ( $formdata->startpath ) )
		$formdata->startpath = '/';
	if ( !isset ( $formdata->excludepath1 ) )
		$formdata->excludepath1 = '';
	if ( !isset ( $formdata->excludepath2 ) )
		$formdata->excludepath2 = '';
	if ( !isset ( $formdata->excludepath3 ) )
		$formdata->excludepath3 = '';
	if ( !isset ( $formdata->datadir ) )
		$formdata->datadir = '';
	if ( !isset ( $formdata->stopwords ) )
		$formdata->stopwords = $DATADB_PATH.'/stop.db';		
	if ( !isset ( $formdata->maxbytesize ) )
		$formdata->maxbytesize = '200000';
	if ( !isset ( $formdata->minwordsize ) )
		$formdata->minwordsize = '3';
	if ( !isset ( $formdata->textsize ) )
		$formdata->textsize = '360';

		
	echo '<br>';
	$menu_form = new form();
	$menu_form->set_select						('MENU');
	$menu_form->set_callback					('');
	$menu_form->set_bgcolor						('EEEEEE');
	$menu_form->set_width						('200');
	
	if ( isset ( $message ) AND strlen ( $message ) > 0 )
		{
		$menu_form->add_area							('0');	
		$menu_form->set_area_title					('0', $MESSAGES[171]);
		$menu_form->add_area_show_textarea  	('0', $message);
		}

	$menu_form->add_area							('1');
	$menu_form->set_area_title					('1', $MESSAGES[172]);
	$menu_form->add_area_input_text			('1', 'startpath', 	'10', $MESSAGES[173],	$formdata->startpath);
	$menu_form->add_area_input_text			('1', 'excludepath1','10', $MESSAGES[174],	$formdata->excludepath1);
	$menu_form->add_area_input_text			('1', 'excludepath2','10', $MESSAGES[175],	$formdata->excludepath2);
	$menu_form->add_area_input_text			('1', 'excludepath3','10', $MESSAGES[176],	$formdata->excludepath3);
	$menu_form->add_area_input_text			('1', 'datadir',		'10', $MESSAGES[177],	$formdata->datadir);
	$menu_form->add_area_input_text			('1', 'stopwords',	'10', $MESSAGES[178], 	$formdata->stopwords);
	
	$menu_form->add_area							('2');
	$menu_form->set_area_title					('2', $MESSAGES[179]);
	$menu_form->add_area_input_text			('2', 'maxbytesize',	'10', $MESSAGES[180], $formdata->maxbytesize);

	$menu_form->add_area							('4');
	$menu_form->set_area_title					('4', $MESSAGES[181]);
	$menu_form->add_area_input_text			('4', 'minwordsize',	'10', $MESSAGES[182], $formdata->minwordsize);

	$menu_form->add_area							('5');
	$menu_form->set_area_title					('5', $MESSAGES[183]);
	$menu_form->add_area_input_text			('5', 'textsize',		'10', $MESSAGES[184], $formdata->textsize);

	$menu_form->add_area							('3');
	$menu_form->set_area_title					('3', $MESSAGES[185]);
	$GZIP[$MESSAGES[186]] = 'off';
	$GZIP[$MESSAGES[187]] = 'on';
	$menu_form->add_area_select_box			('3', 'gzipcompr', $MESSAGES[185].':', $GZIP);
	
		
	$menu_form->add_area_hidden_value   	('1', 'phpcmsaction' , 'SEARCH');
	$menu_form->add_area_hidden_value   	('1', 'action' , 'startindex');
	$menu_form->add_button						('submit', 'index', $MESSAGES[188]);
	$menu_form->compose_form();
	}

########################################################################	
# check formdata
########################################################################

function select_action()
	{
	global $DEFAULTS, $formdata, $session, $MESSAGES;

	# set values
	if (isset($formdata->index))
		{
		$formdata->startpath = trim ( $formdata->startpath );
		if ( !file_exists ( $DEFAULTS->DOCUMENT_ROOT.$formdata->startpath ) OR $formdata->startpath == '')
			{
			draw_search_menu( $MESSAGES[189] );
			soft_exit();
			}
		else
			$session->set_var('startpath', $formdata->startpath);
			
		$formdata->excludepath1 = trim ( $formdata->excludepath1 );
		if ( !file_exists ( $DEFAULTS->DOCUMENT_ROOT.$formdata->excludepath1 ))
			{
			draw_search_menu( $MESSAGES[190] );
			soft_exit();
			}
		else
			$session->set_var('excludepath1', $formdata->excludepath1);
			
		$formdata->excludepath2 = trim ( $formdata->excludepath2 );
		if ( !file_exists ( $DEFAULTS->DOCUMENT_ROOT.$formdata->excludepath2 ))
			{
			draw_search_menu( $MESSAGES[191] );
			soft_exit();
			}
		else
			$session->set_var('excludepath2', $formdata->excludepath2);
			
		$formdata->excludepath3 = trim ( $formdata->excludepath3 );
		if ( !file_exists ( $DEFAULTS->DOCUMENT_ROOT.$formdata->excludepath3 ))
			{
			draw_search_menu( $MESSAGES[192] );
			soft_exit();
			}
		else
			$session->set_var('excludepath3', $formdata->excludepath3);
			
		$formdata->datadir = trim ( $formdata->datadir );
		if ( !file_exists ( $DEFAULTS->DOCUMENT_ROOT.$formdata->datadir ) OR $formdata->datadir == '')
			{
			draw_search_menu( $MESSAGES[193] );
			soft_exit();
			}
			
		# check rights
		@$fp = fopen ($DEFAULTS->DOCUMENT_ROOT.$formdata->datadir.'test.db', 'w+');
		if ( !$fp )
			$norights = true;
		else
			{
			fclose ($fp);
			unlink ($DEFAULTS->DOCUMENT_ROOT.$formdata->datadir.'test.db');
			$session->set_var('datadir', $formdata->datadir);
			}
			
		if (isset($norights))
			{
			draw_search_menu( $MESSAGES[194] );
			soft_exit();			
			}

		$formdata->stopwords = trim ( $formdata->stopwords );
		if ( !file_exists ( $DEFAULTS->DOCUMENT_ROOT.$formdata->stopwords ) OR $formdata->stopwords == '')
			{
			draw_search_menu( $MESSAGES[195] );
			soft_exit();
			}
		else
			$session->set_var('stopwords', $formdata->stopwords);

		$formdata->maxbytesize = trim ( $formdata->maxbytesize );
		if ( !isset ($formdata->maxbytesize) OR $formdata->maxbytesize < 1000)
			{
			draw_search_menu( $MESSAGES[196] );
			soft_exit();
			}
		else
			$session->set_var('maxbytesize', $formdata->maxbytesize);
			
		$formdata->minwordsize = trim ( $formdata->minwordsize );
		if ( !isset ($formdata->minwordsize) OR $formdata->minwordsize < 3)
			{
			draw_search_menu( $MESSAGES[197] );
			soft_exit();
			}
		else
			$session->set_var('minwordsize', $formdata->minwordsize);

		$formdata->textsize = trim ( $formdata->textsize );
		if ( !isset ($formdata->textsize) OR $formdata->textsize < 10)
			{
			draw_search_menu( $MESSAGES[198] );
			soft_exit();
			}
		else
			$session->set_var('textsize', $formdata->textsize);
			
		$session->set_var('gzipcompr', $formdata->gzipcompr);			

		$session->set_var('task', 'indexer');
		$session->set_var('step', '0');
		indexer();
		}
	}

########################################################################	
# start indexer
########################################################################

function indexer()
	{
	global $PHPCMS_INCLUDEPATH, $session, $DEFAULTS, $MESSAGES;
	global $SEARCHDATADIR, $STOP, $STOP_MAX, $MIN_WORD_SIZE;
	global $EXTENSION,$PEXTENSION,$EXDIR,$PHPCMS_DOC_ROOT, $MAX_BYTE_SIZE;
	
	include ($PHPCMS_INCLUDEPATH.'/class.search_indexer_phpcms.php');
	soft_exit();
	}

########################################################################	
# selection
########################################################################

set_time_limit(0);

$formdata = new get_form;

if ( isset($formdata->select) )
	$select = $formdata->u_select;

if ( isset ( $session->vars['select'] ) )
	$select = strtoupper ( $session->vars['select'] );

 if ( !isset ($select) )
	$select = '';
	
switch ( $select )
	{
	case 'INDEXER':
		indexer();
		soft_exit();
	case 'MENU':
		select_action();
		soft_exit();
	default:
		draw_search_menu($MESSAGES[199]);
	}

soft_exit();
?>